Page MenuHomePhabricator

Package and deploy varnish 6.0.7
Closed, ResolvedPublic

Description

Varnish 6.0.7 was released on 2020-11-06. The new version includes the following changes:

  • Add support for more HTTP response code reasons (3428).
  • Add weighted backends to vmod_shard.
  • Fix an issue where an undefined value is returned when converting a VCL_TIME to a string. (3308)
  • Fix an issue where the wrong workspace is used during vcl_pipe. (3329) (3361) (3385)
  • Fix an assert situation when running out of workspace during h2 delivery. (3382)
  • Fix an issue where we can incorrectly re-use a req.body. This introduces a new bereq body attribute: bo->bereq_body. (3093)
  • Fix send_timeout for certain kinds of slow HTTP1 writes. (3189)
  • Fix std.rollback() when not followed by a restart/retry. (3009)
  • Fix an assert situation when running out of workspace during ESI processing. (3253)
  • Don't override Content-Encoding on 304 responses. (3169)
  • Better thread creation signalling. (2942)
  • Fix an error where when using a certain internal status code will trigger an assert. (3301)
  • Fix a situation where a closed connection is recycled. (3266)
  • Fix an assert situation when doing a conditional fetch. (3273)
  • Fix an issue where varnishadm improperly returns an empty 200 response when you overflow. (3038)
  • Add new VCL parameters to warn when too many VCLs are loaded: max_vcl and max_vcl_handling. (2713)
  • Fix an issue where we can use a streaming object in a conditional fetch too soon. (3089)
  • Fix an issue where the Age is dropped when passing. (3221)
  • Expose the master and worker PIDs via the CLI: varnishadm pid. (3171)

This task tracks the packaging and deployment work required to upgrade to 6.0.7.

Event Timeline

ema created this task.Nov 25 2020, 11:10 AM
Restricted Application added a project: SRE. · View Herald TranscriptNov 25 2020, 11:10 AM
Restricted Application added a subscriber: Aklapper. · View Herald Transcript
ema triaged this task as Medium priority.Nov 25 2020, 11:10 AM
ema added a comment.Nov 25 2020, 11:30 AM

I've tried building 6.0.7 on my workstation to double-check the changes between 6.0.6 and 6.0.7 with debdiff. When running the tests, ./bin/varnishtest/tests/m00035.vtc fails with a segmentation fault:

***  v1    0.5 debug|Error: Child (484139) Panic at: Wed, 25 Nov 2020 11:21:49 GMT
***  v1    0.5 debug|Wrong turn at cache/cache_main.c:284:
***  v1    0.5 debug|Signal 11 (Segmentation fault) received at 0x7fbda0623fe8 si_code 2
***  v1    0.5 debug|THIS PROBABLY IS A STACK OVERFLOW - check thread_pool_stack parameter
***  v1    0.5 debug|version = varnish-6.0.7 revision 525d371e3ea0e0c38edd7baf0f80dc226560f26e, vrt api = 7.1
***  v1    0.5 debug|ident = Linux,5.9.0-1-amd64,x86_64,-jnone,-sdefault,-sdefault,-hcritbit,epoll
***  v1    0.5 debug|now = 1364723.999235 (mono), 1606303309.071339 (real)
***  v1    0.5 debug|Backtrace:
***  v1    0.5 debug|  0x559deafe7d23: varnishd(+0x4dd23) [0x559deafe7d23]
***  v1    0.5 debug|  0x559deb053374: varnishd(VAS_Fail+0x14) [0x559deb053374]
***  v1    0.5 debug|  0x559deafe2dc5: varnishd(+0x48dc5) [0x559deafe2dc5]
***  v1    0.5 debug|  0x7fbda0a88140: /lib/x86_64-linux-gnu/libpthread.so.0(+0x14140) [0x7fbda0a88140]
***  v1    0.5 debug|  0x7fbd9e35604c: [0x7fbd9e35604c]

Full log on P13407.

ema added a comment.Nov 25 2020, 2:01 PM

I've tried building 6.0.7 on my workstation to double-check the changes between 6.0.6 and 6.0.7 with debdiff. When running the tests, ./bin/varnishtest/tests/m00035.vtc fails with a segmentation fault:

Note that this happens with dpkg-buildpackage on my workstation, running sid. There's no issue in a buster chroot on deneb.

ema moved this task from Triage to Feature Requests on the Traffic board.Nov 26 2020, 9:06 AM
ema added a subscriber: Gilles.Nov 26 2020, 9:10 AM

@Gilles: FYI during the next few weeks we'll be upgrading to this latest bugfix release. The list of changes (see task description) does not seem to suggest anything that could have an obvious performance impact, but you never know. I am going to upgrade one single node first, see how it behaves for a while and then proceed with the rest.

Mentioned in SAL (#wikimedia-operations) [2020-11-26T09:26:05Z] <ema> deployment-cache-text06: upgrade Varnish to 6.0.7-1wm1 T268736

Mentioned in SAL (#wikimedia-operations) [2020-11-30T10:11:18Z] <ema> cp4032: upgrade varnish to 6.0.7-1wm1 T268736

Mentioned in SAL (#wikimedia-operations) [2020-11-30T13:58:08Z] <ema> varnish 6.0.7-1wm1 uploaded to apt.wikimedia.org component/varnish6 T268736

Mentioned in SAL (#wikimedia-operations) [2020-11-30T15:34:13Z] <ema> cp3054: upgrade varnish to 6.0.7-1wm1 T268736 T264398

ema added a comment.Dec 3 2020, 9:37 AM

Varnish 6.0.7-1wm1 has been working well on both cp4032 and cp3054, upgrading all other nodes (except for cp3052 which is running 5.1.3-1wm15 as part of T264398).

Mentioned in SAL (#wikimedia-operations) [2020-12-03T09:40:57Z] <ema> A:cp start rolling varnish upgrade to 6.0.7-1wm1 T268736

ema closed this task as Resolved.Dec 3 2020, 1:36 PM
ema claimed this task.

6.0.7-1wm1 deployed fleet-wide, closing.